/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: D
//!	Generated Date	: Mon, 13, Jan 2014  
	File Path	: DefaultComponent\DefaultConfig\D.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "D.h"
//## link itsC
#include "C.h"
//#[ ignore
#define Default_D_D_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class D
D::D(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(D, D(), 0, Default_D_D_SERIALIZE);
    setActiveContext(theActiveContext, false);
    itsC = NULL;
    initStatechart();
}

D::~D() {
    NOTIFY_DESTRUCTOR(~D, true);
    cleanUpRelations();
}

C* D::getItsC() const {
    return itsC;
}

void D::setItsC(C* p_C) {
    _setItsC(p_C);
}

bool D::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void D::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void D::cleanUpRelations() {
    if(itsC != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsC");
            itsC = NULL;
        }
}

void D::__setItsC(C* p_C) {
    itsC = p_C;
    if(p_C != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsC", p_C, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsC");
        }
}

void D::_setItsC(C* p_C) {
    __setItsC(p_C);
}

void D::_clearItsC() {
    NOTIFY_RELATION_CLEARED("itsC");
    itsC = NULL;
}

void D::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.s_0");
        rootState_subState = s_0;
        rootState_active = s_0;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus D::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case s_0:
        {
            if(IS_EVENT_TYPE_OF(F_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.s_0");
                    NOTIFY_STATE_ENTERED("ROOT.s_1");
                    pushNullTransition();
                    rootState_subState = s_1;
                    rootState_active = s_1;
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
            break;
        }
        case s_1:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.s_1");
                    //#[ transition 2 
                    getItsC()->GEN(G);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.s_0");
                    rootState_subState = s_0;
                    rootState_active = s_0;
                    NOTIFY_TRANSITION_TERMINATED("2");
                    res = eventConsumed;
                }
            
            break;
        }
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedD::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsC", false, true);
    if(myReal->itsC)
        {
            aomsRelations->ADD_ITEM(myReal->itsC);
        }
}

void OMAnimatedD::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case D::s_0:
        {
            s_0_serializeStates(aomsState);
            break;
        }
        case D::s_1:
        {
            s_1_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedD::s_1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s_1");
}

void OMAnimatedD::s_0_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s_0");
}
//#]

IMPLEMENT_REACTIVE_META_P(D, Default, Default, false, OMAnimatedD)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\D.cpp
*********************************************************************/
